<template>
  <div id="pageDashboard">
    <v-container grid-list-xl fluid>
      <v-layout row wrap>
        <!-- mini statistic start -->
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 1"
            :number="statistic.candidate1"
            sub-title="Votos"
            color="primary"
          ></mini-statistic>
        </v-flex>
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 2"
            :number="statistic.candidate2"
            sub-title="Votos"
            color="info"
          ></mini-statistic>
        </v-flex>
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 3"
            :number="statistic.candidate3"
            sub-title="Votos"
            color="warning"
          ></mini-statistic>
        </v-flex>
        <!-- mini statistic  end -->
      </v-layout>
      <v-divider></v-divider>
      <v-card-text class="pa-0">
        <v-data-table :headers="headers" :items="votes" class="elevation-1">
          <template slot="items" slot-scope="props">
            <td>{{ props.item.hash}}</td>
            <td>{{ props.item.voto}}</td>
            <td>{{getDate(props.item.timestamp) }}</td>
          </template>
        </v-data-table>
      </v-card-text>
    </v-container>
  </div>
</template>

<script>
import _ from "lodash";
import Material from "vuetify/es5/util/colors";
import MiniStatistic from "@/components/widgets/statistic/MiniStatistic";
import moment from "moment";
import momentTimezone from "moment-timezone";

//Providers
import BlockchainProvider from "@/providers/Blockchain";
const BlockchainResource = new BlockchainProvider();

export default {
  components: {
    MiniStatistic
  },
  data: () => ({
    color: Material,
    loading: false,
    locations_permission: [],
    providers_permission: [],
    statistic: {
      candidate1: 0,
      candidate2: 0,
      candidate3: 0
    },
    votes: [],
    search: "",
    items: []
  }),
  mounted() {
    this.getBlocks();
  },
  computed: {
    headers() {
      let _headers = [
        {
          text: "Has",
          value: "Has"
        },
        {
          text: "Candidato",
          value: "Candidato"
        },
        {
          text: "Fecha",
          value: "Fecha"
        }
      ];
      return _headers;
    }
  },
  methods: {
    getBlocks() {
      let self = this;
      BlockchainResource.getBlocks()
        .then(response => {
          //this.votes = response.data;
          // console.log(this.votes);
          _.map(response.data, function(item, index) {
            if (index > 0) {
              self.votes.push(item);
            }

            switch (item.voto) {
              case 1:
                self.statistic.candidate1 += 1;
                break;
              case 2:
                self.statistic.candidate2 += 1;
                break;
              case 3:
                self.statistic.candidate3 += 1;
                break;
            }
          });
        })
        .catch(error => console.log(error));
    },
    getDate(timestamp) {
      return moment(timestamp).format("YYYY-MM-DD HH:mm:ss");
    }
  }
};
</script>
